# coding: utf-8
lib = File.expand_path('../lib', __FILE__)
$LOAD_PATH.unshift(lib) unless $LOAD_PATH.include?(lib)
require 'perkins/version'

Gem::Specification.new do |spec|
  spec.name          = "perkins"
  spec.version       = Perkins::VERSION
  spec.authors       = ["miguel michelson"]
  spec.email         = ["miguelmichelson@gmail.com"]
  spec.summary       = "A travis compatible standalone CI solution for ruby"
  spec.description   = "Continous integration solution compatible with travis.ci"
  spec.homepage      = ""
  spec.license       = "MIT"

  spec.files         = `git ls-files -z`.split("\x0")
  spec.executables   = spec.files.grep(%r{^bin/}) { |f| File.basename(f) }
  spec.test_files    = spec.files.grep(%r{^(test|spec|features)/})
  spec.require_paths = ["lib"]

  spec.add_dependency 'activesupport', ['>= 3', '< 4.1']
  spec.add_dependency 'activerecord', ['>= 3', '< 4.1']

  spec.add_dependency "sinatra-contrib"
  spec.add_dependency "sqlite3"

  spec.add_dependency("git")
  spec.add_dependency("redis")
  spec.add_dependency("thor")
  spec.add_dependency("sinatra")
  spec.add_dependency("haml")
  spec.add_dependency("sprockets")
  spec.add_dependency("haml_coffee_assets")
  spec.add_dependency("yui-compressor")
  spec.add_dependency("rdiscount")
  spec.add_dependency("travis-yaml")
  spec.add_dependency("redis-namespace")
  spec.add_dependency("thin")
  spec.add_dependency("sidekiq")
  spec.add_dependency("dotenv-rails")

  spec.add_dependency "warden-github", "~>1.0"

  # I find it well worth to include CoffeeScript and SASS as well
  spec.add_dependency("coffee-script")
  spec.add_dependency("sass")


  spec.add_development_dependency "bundler", "~> 1.7"
  spec.add_development_dependency "rake", "~> 10.0"
  spec.add_development_dependency "fakeredis"
end
